#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "common1.h"
#include "common3.h"


  void climate(flag,cemi,semi)
  int flag;
  double **cemi,**semi;
{ double **ref_v,*emi_tl,*emi_ff,*emi_ts,*emi_sit;
  double *plant,*rgrwt,*detri,*soil,*etot,*flux,*dbdt,*pcc;
  double *qco2,*qmeth,*qnit,*qtot,*qo3s,*qo3t,*qcfc,*qso2d,*qso2i,*qbio;
  double **con,**emi,**toc,**tem,**sea;
  double delt,tmp1,tmp2,v;
  int i,j,k,l,mem,k0,n;
  int *year;

  mem=400;

  year=m_iarr1(N_TMP+1);

  plant=m_darr1(mem);  rgrwt=m_darr1(mem);
  detri=m_darr1(mem);  soil=m_darr1(mem);
  etot=m_darr1(mem);   flux=m_darr1(mem);
  dbdt=m_darr1(mem);   pcc=m_darr1(5);

  qco2=m_darr1(mem);   qmeth=m_darr1(mem);
  qnit=m_darr1(mem);   qcfc=m_darr1(mem);
  qo3s=m_darr1(mem);   qo3t=m_darr1(mem);
  qtot=m_darr1(mem);   qso2d=m_darr1(mem);
  qso2i=m_darr1(mem);  qbio=m_darr1(mem);

  emi=m_darr2(35,mem);
  con=m_darr2(35,mem);
  tem=m_darr2(7,mem);
  sea=m_darr2(4,mem);
  emi_tl=m_darr1(mem);
  emi_ff=m_darr1(mem);
  emi_ts=m_darr1(mem);
  emi_sit=m_darr1(mem);

  ref_v=m_darr2(4,N_TMP);
  d_coeff=m_darr4(4,N_SCEM,N_TIME,N_TIME);
  d_const=m_darr3(4,N_SCEM,N_TIME);

  ico2d=0; ico2i=1; ich4=2; in2o=3; ico=4; ivoc=5; inox=6; isox=7; icfc=8;

  year[0]=(int) start_yr;
  for(i=0;i<N_TMP;i++) year[i+1]=(int) n_yr[i];

  read_clima(emi,con,tem);
  toc=m_darr2(2,nbox);
  init_PARAM(con);

/* Inverse Problem */

  inv_CO2(con[ico2i],con[ich4],emi[ico2i],emi[ico2d],
                   plant,detri,soil,etot,flux,dbdt,rgrwt,pcc);
  for(i=0;i<5;i++) pcc90[i]=pcc[i];
  for(i=0;i<226;i++) emi_tl[i]=emi[ico2i][i];
  for(i=0;i<226;i++) emi_ts[i]=emi[isox][i];


/* Numerical Derivation */

  if(flag==1) {
    emi_gas=m_darr3(N_SCE,6,N_TMP);
    con_gas=m_darr3(N_SCE,3,N_TMP);
    del_q=m_darr3(N_SCE,10,N_TMP);
    tmp_rise=m_darr3(N_SCE,7,N_TMP);
    sea_rise=m_darr3(N_SCE,5,N_TMP);
    rtmp_rise=m_darr3(N_SCE,LR,N_TMP);
  }
  else rtmp_risex=m_darr3(N_SCE,LR,N_TMP);

  for(l=0;l<N_SCE;l++) {

   /* Interpolation between 1991 and 1999 */
	  /* emi[ico2i][226] is used as the emission from cement production in 1990 */

	for(i=1;i<10;i++) { 
      emi_ff[i+225]=emi[ico2i][225]-emi[ico2i][226]
		  +(cemi[l][0]-emi[ico2i][225]+emi[ico2i][226])/10.*(double) i;
	  emi_sit[i+225]=emi[isox][225]+(semi[l][0]-emi[isox][225])/10.*(double) i;
	}
    interpolate(N_TMP+1,year,cemi[l],emi_ff);
    interpolate(N_TMP+1,year,semi[l],emi_sit);
    for(j=226;j<year[N_TMP]-1764;j++) emi_tl[j]=emi_ff[j]+emi[ico2i][j];
    for(j=226;j<year[N_TMP]-1764;j++) emi_ts[j]=emi_sit[j]+emi[isox][j];
    init_VAR(emi_tl,emi[ich4],emi_ts,con[ich4],toc,tem,pcc);

    for(i=226;i<year[N_TMP]-1764;i++) {
		cal_CH4(i,con[ich4],emi[ich4],emi[ico],emi[ivoc],emi[inox]);
		cal_CO2(i,con[ico2i],con[ich4],emi_tl,emi[ico2d],
            plant,detri,soil,etot,flux,dbdt,rgrwt,pcc);
		cal_N2O(i,con[in2o],emi[in2o]);
      cal_CFCs(i,con,emi);
    }


    for(i=1;i<year[N_TMP]-1764;i++) {
      cal_RADFORCE(i,con,emi_ts,emi_tl,emi[ico2d],rgrwt,
                 qco2,qmeth,qnit,qcfc,qo3s,qo3t,qtot,qso2d,qso2i,qbio);
      cal_TEMPERAT(i,qtot,qso2d,qso2i,qo3t,toc,tem);
      cal_SEALEVEL(i,toc,tem[4],sea);
    }

    k0=225;
 
    if(flag==1) {
      for(i=0;i<N_TMP;i++) {
        k=year[i+1]-1765;
        emi_gas[l][0][i]=emi_ff[k];
        emi_gas[l][1][i]=emi[ico2i][k];
        emi_gas[l][2][i]=emi[ico2d][k];
        emi_gas[l][3][i]=emi[ich4][k];
        emi_gas[l][4][i]=emi_sit[k];
        emi_gas[l][5][i]=emi[isox][k];
        con_gas[l][0][i]=con[ico2i][k];
        con_gas[l][1][i]=con[ich4][k];
        con_gas[l][2][i]=con[in2o][k];
        del_q[l][0][i]=qco2[k]-qco2[k0];
        del_q[l][1][i]=qmeth[k]-qmeth[k0];
        del_q[l][2][i]=qnit[k]-qnit[k0];
        del_q[l][3][i]=qcfc[k]-qcfc[k0];
        del_q[l][4][i]=qo3s[k]-qo3s[k0];
        del_q[l][5][i]=qo3t[k]-qo3t[k0];
        del_q[l][6][i]=qso2d[k]-qso2d[k0];
        del_q[l][7][i]=qso2i[k]-qso2i[k0];
        del_q[l][8][i]=qbio[k]-qbio[k0];
        del_q[l][9][i]=0.;
        for(j=0;j<9;j++) del_q[l][9][i]+=del_q[l][j][i];
        tmp_rise[l][0][i]=tem[0][k];
        tmp_rise[l][1][i]=tem[1][k];
        tmp_rise[l][2][i]=fland[0]*tmp_rise[l][0][i]
                          +focean[0]*tmp_rise[l][1][i];
        tmp_rise[l][3][i]=tem[2][k];
        tmp_rise[l][4][i]=tem[3][k];
        tmp_rise[l][5][i]=fland[1]*tmp_rise[l][2][i]
                          +focean[1]*tmp_rise[l][3][i];
        tmp_rise[l][6][i]=tem[4][k];
        sea_rise[l][0][i]=sea[0][k]-sea[0][k0];
        sea_rise[l][1][i]=sea[1][k]-sea[1][k0];
        sea_rise[l][2][i]=sea[2][k]-sea[2][k0];
        sea_rise[l][3][i]=sea[3][k]-sea[3][k0];
        sea_rise[l][4][i]=0.;
        for(j=0;j<4;j++) sea_rise[l][4][i]+=sea_rise[l][j][i];

        if(ictrl11==1) {
          tmp1=qco2[k]+qmeth[k]+qnit[k]+qcfc[k]+qo3s[k]+qo3t[k];
          tmp2=qso2d[k]+qso2i[k]+qbio[k];
          for(n=0;n<LR;n++) {
            v=0.;
            for(j=0;j<LR;j++) v+=soxemi[l][j][i+1]*rtmps[j][n];
            v*=(tmp2/tsoxemi[l][i+1]);
            v+=tmp1*rtmpc[n];
	        rtmp_rise[l][n][i]=v/(tmp1+tmp2)*tem[4][k];
          }
		}
      }
    }
    else if(flag==0) {
      for(i=0;i<N_TMP;i++) {
        k=year[i+1]-1765;
        tmp1=qco2[k]+qmeth[k]+qnit[k]+qcfc[k]+qo3s[k]+qo3t[k];
        tmp2=qso2d[k]+qso2i[k]+qbio[k];
        v=tem[4][k]/(tmp1+tmp2);
        ref_v[0][i]=con[ico2i][k];
        ref_v[1][i]=tem[4][k];
        ref_v[2][i]=tmp1*v;
        ref_v[3][i]=tmp2*v;
      }

      for(i=0;i<N_TMP;i++) {
        delt=0.01;
        cemi[l][i+1]+=delt;
        interpolate(N_TMP+1,year,cemi[l],emi_ff);
        emi_tl[225]=emi[ico2i][225];
        for(j=226;j<year[N_TMP]-1764;j++) emi_tl[j]=emi_ff[j]+emi[ico2i][j];
        cemi[l][i+1]-=delt;
        init_VAR(emi_tl,emi[ich4],emi_ts,con[ich4],toc,tem,pcc);
        for(j=226;j<year[N_TMP]-1764;j++) {
          cal_CH4(j,con[ich4],emi[ich4],emi[ico],emi[ivoc],emi[inox]);
          cal_CO2(j,con[ico2i],con[ich4],emi_tl,emi[ico2d],
              plant,detri,soil,etot,flux,dbdt,rgrwt,pcc);
          cal_N2O(j,con[in2o],emi[in2o]);
          cal_CFCs(j,con,emi);
        }
        for(j=1;j<year[N_TMP]-1764;j++) {
          cal_RADFORCE(j,con,emi_ts,emi_tl,emi[ico2d],rgrwt,
                qco2,qmeth,qnit,qcfc,qo3s,qo3t,qtot,qso2d,qso2i,qbio);
          cal_TEMPERAT(j,qtot,qso2d,qso2i,qo3t,toc,tem);
        }
        for(j=0;j<N_TMP;j++) {
          k=year[j+1]-1765;
          tmp1=qco2[k]+qmeth[k]+qnit[k]+qcfc[k]+qo3s[k]+qo3t[k];
          tmp2=qso2d[k]+qso2i[k]+qbio[k];
          v=tem[4][k]/(tmp1+tmp2);
          d_coeff[0][l][j][i]=(con[ico2i][k]-ref_v[0][j])/delt;
          d_coeff[1][l][j][i]=(tem[4][k]-ref_v[1][j])/delt;
		  d_coeff[2][l][j][i]=(tmp1*v-ref_v[2][j])/delt;
	      d_coeff[3][l][j][i]=(tmp2*v-ref_v[3][j])/delt;
        }
      }
      for(k=0;k<4;k++) {
        for(i=0;i<N_TMP;i++) {
          d_const[k][l][i]=-ref_v[k][i];
          for(j=0;j<=i;j++) d_const[k][l][i]+=d_coeff[k][l][i][j]*cemi[l][j+1];
		}
	  }
    }
  }

  free(year);  free(plant);  free(rgrwt);  free(detri);
  free(soil);  free(etot);   free(flux);   free(dbdt);
  free(pcc);
  free(qco2);  free(qmeth);  free(qnit);   free(qcfc);
  free(qo3s);  free(qo3t);   free(qtot);   free(qso2d);
  free(qso2i); free(qbio);
  for(i=0;i<28;i++) free(emi[i]);
  for(i=0;i<28;i++) free(con[i]);
  for(i=0;i<7;i++) free(tem[i]);
  for(i=0;i<4;i++) free(sea[i]);
  for(i=0;i<2;i++) free(ref_v[i]);
  free(emi_tl);  free(emi_ff);
  for(i=0;i<2;i++) free(toc[i]);
}

 void init_PARAM(c)
 double **c;
{ double dy,dd,x1,x2,zed;
  int i; 
/* Gas Concentration Model */
      /* Parameters used in smooth transition method */
  xxe[0]=ell[0]-dee[0];xxe[1]=ell[0]+dee[1];
  xxe[2]=ell[1]-dee[2];xxe[3]=ell[1]+dee[3];
  xxe[4]=ell[2]-dee[4];xxe[5]=ell[2]+dee[5];

  for(i=0;i<5;i++) {
     dar1[i]=(ar[5+i]-ar[i])/(ell[1]-ell[0]);
     dar2[i]=(ar[10+i]-ar[5+i])/(ell[2]-ell[1]);

     dy=dar1[i]*dee[1];x1=dee[0]+dee[1];x2=x1*x1;
     axfr[i]=(dar1[i]-2.0*dy/x1)/x2;
     bxfr[i]=(3.0*dy/x1-dar1[i])/x1;

     cxfr[5+i]=ar[5+i]-dar1[i]*dee[2];
     dy=dar1[i]*dee[2]+dar2[i]*dee[3];
     dd=dar1[i]+dar2[i];
     x1=dee[2]+dee[3];x2=x1*x1;
     axfr[5+i]=(dd-2.0*dy/x1)/x2;
     bxfr[5+i]=(3.0*dy/x1-dd-dar1[i])/x1;

     cxfr[10+i]=ar[10+i]-dar2[i]*dee[4];
     dy=dar2[i]*dee[4];
     x1=dee[4]+dee[5];x2=x1*x1;
     axfr[10+i]=(dar2[i]-2.0*dy/x1)/x2;
     bxfr[10+i]=(3.0*dy/x1-2.0*dar2[i])/x1; }

    /* Parameters used in terrestrial carbon cycle */
  x1=cmgp*gpp0-res0;
  tplant=plant0/x1;
  x2=cmgh*gpp0+cplh*x1-ham-hbs;
  tdetri=detri0/x2;
  tsoil=soil0/(cmgs*gpp0+chqs*x2+hbs-scm+cpls*x1);
/*  printf(" Time Constants P: %f  H: %f  S:  %f\n", tplant,tdetri,tsoil);
  printf("\n");*/
  zzp1=1.0-0.5/tplant; zzp2=1.0+0.5/tplant;
  zzh1=1.0-0.5/tdetri; zzh2=1.0+0.5/tdetri;
  zzs1=1.0-0.5/tsoil;  zzs2=1.0+0.5/tsoil;

  for(i=0;i<5;i++) refc[i]=psi/tr[i]; refc[0]=0.;

  bfert=((680.-conb)-rco2*(340.-conb))
       /((rco2-1.)*(680.-conb)*(340.-conb));
  cfert=(1.+bfert*(con0-conb))/(con0-conb);

  if(ipch4==0) fffrac=0.;
  methtau=tau90;

/* Radiative Forcing Model */
  if(iph2o==0) qcc[2]=0.;

  if(ipo3==1) {
    cl90=0.;
    for(i=0;i<27;i++)
      cl90+=odpcfc[i]*c[i+icfc][221];
  }
  else {
    cl90=1.;
    qcc[5]=0.;
  }

  if(ipso2==0) {
    aso2=0.;
    bso2=0.;
  }

/* Temperature Rise Model */
  q2x=qcc[0]*log(2.);
  dt=1./(double)ntp;
  focean[0]=1.-fland[0]; focean[1]=1.-fland[1];
  xk=yk*3600.*24.*365.25/10000.;
  xlam=q2x/t2x;
  fkk=3600.*24.*365.25/4.1856/rho/specht*1.e-6;
  dth=dt/hm;
  xlamo=2.*xlam/(xlamr*(fland[0]+fland[1])+focean[0]+focean[1]);
  xlaml=xlamr*xlamo;

/* Sea Level Rise Model */
   zed=hm/2.;
   pres[0]=0.0098*(0.1005*zed+10.5*(exp(-zed/3500.)-1.));
   item[0]=20.98-13.12/hm-0.04025*hm;
   for(i=1;i<nbox;i++) {
      zed=hm+i*dz+dz*0.5;
      pres[i]=0.0098*(0.1005*zed+10.5*(exp(-zed/3500.)-1.));
      zed/=100.;
      if(zed<1.3)      item[i]=18.98-4.025*zed;
      else if(zed<5.)  item[i]=17.01-2.829*zed+0.228*zed*zed;
      else if(zed<25.) item[i]=exp(exp(1.007-0.0665*zed));
      else             item[i]=2.98-0.052*zed;
    }
}


 void init_VAR(eco2,ech4,sox,con,tdo,temp,pcc)
 double *eco2,*ech4,*sox,*con,**tdo,**temp,*pcc;
{ int i;
  double cff,emis90,tinv90,del,avch4,ch4tau;

  cff=fffrac*cmtb*12./16./1000.;
  avch4=(con[225]+con[224])*0.5;
  ch4tau=tau90*pow(avch4/con[225],powch4a);
  eco2[225]+=cff/ch4tau*(avch4-con[0]);

  tinv90=1./tau90+1./tausoil;
  emis90=cmtb*(con[225]-con[224]+(con[225]+con[224])*0.5*tinv90);
  del=-ech4[225]+emis90;
  for(i=0;i<5;i++)
    ech4[225+i]+=del*(1.-0.2*i);

  for(i=0;i<17;i++)
    sox[208+i]=sox[208]+(sox[225]-sox[208])/17.*i;
  for(i=0;i<nbox;i++) {
    tdo[0][i]=0.;
    tdo[1][i]=0.;
  }
  for(i=0;i<5;i++) temp[i][0]=0.;

  for(i=0;i<5;i++) pcc[i]=pcc90[i];
}
 

 void cal_RADFORCE(n,c,es,e2i,e2d,rg,qc2,qm,qn,qcf,qos,qot,qt,qsd,qsi,qb)
 double **c,*es,*e2i,*e2d,*rg,
        *qc2,*qm,*qn,*qt,*qcf,*qos,*qot,*qsd,*qsi,*qb;
 int n;
{  double qch4,qn2o,qh2o,qozone;
   double aa,ff0,ff1,ff2,yy,yy0,ww,ww0,zz,zz0;
   double tsf0,tsf1,emis,cc;
   int i;

/* by CO2 Concentration */
  qc2[n]=qcc[0]*log(c[ico2i][n]/c[ico2i][0]);

/* by CH4 Concentration */
  qch4=qcc[1]*(sqrt(c[ich4][n])-sqrt(c[ich4][0]));

/* by Stratspheric H2O */
  qh2o=qcc[2]*qch4;

/* by Tropospheric O3 */
  qozone=qcc[6]*(c[ich4][n]-c[ich4][0])/(c[ich4][225]-c[ich4][0]);

/************ Feb. 2003 ************/
  qot[n]=qcc[7]*(e2i[n]-e2i[0])/(e2i[225]-e2i[0]);

/************ Feb. 2003 ************/
/*
  if(n<226)
    qot[n]=qcc[7]*(e2i[n]-e2i[0])/(e2i[225]-e2i[0]);
  else
    qot[n]=qcc[7];
*/

/* by Nitrous Oxide */
  qn2o=qcc[3]*(sqrt(c[in2o][n])-sqrt(c[in2o][0]));

/* by Halocarbons */
  qcf[n]=0.;
  for(i=0;i<27;i++)
    qcf[n]+=qcc[4]*rfcfc[i]*c[i+icfc][n];

/* by Stratospheric Ozone depletion */ 
  aa=0.;
  if(n>185)
    for(i=0;i<27;i++)
      aa+=odpcfc[i]*c[i+icfc][n-lag]; 
  qos[n]=qcc[5]*pow(aa/cl90,expcl);

/* Over-lapping of CH4 and N2O */
  yy0=c[ich4][0]/1000.; ww0=c[in2o][0]/1000.; zz0=yy0*ww0;
  aa=ovlap[0]*pow(zz0,ovlap[2])+ovlap[1]*yy0*pow(zz0,ovlap[3]);
  ff0=ovlap[4]*log(1.+aa);
  yy=c[ich4][n]/1000.;  zz=yy*ww0;
  aa=ovlap[0]*pow(zz,ovlap[2])+ovlap[1]*yy*pow(zz,ovlap[3]);
  ff1=ovlap[4]*log(1.+aa);
  ww=c[in2o][n]/1000.; zz=yy0*ww;
  aa=ovlap[0]*pow(zz,ovlap[2])+ovlap[1]*yy0*pow(zz,ovlap[3]);
  ff2=ovlap[4]*log(1.+aa);

  qm[n]=qch4+ff0-ff1+qh2o+qozone;
  qn[n]=qn2o+ff0-ff2;

/* Total Radiative Forcing */
  qt[n]=qc2[n]+qm[n]+qn[n]+qcf[n]+qos[n];

/* Global Sulphate Aerosol Forcing */
    /*      tall stack effect */
  if(n < 185)  tsf0=talstk;
  else if(n < 205) tsf0=talstk+(1.-talstk)*(n-185)/20.;
  else tsf0=1.;
  if(n < 184)  tsf1=talstk;
  else if(n < 204) tsf1=talstk+(1.-talstk)*(n-184)/20.;
  else tsf1=1.;

/*  emis=(tsf0*es[n]+tsf1*es[n+1])*0.5;
  cc=(es[225]+es[226])*0.5; */

  emis=tsf0*es[n];
  cc=es[225]; 

  qsd[n]=-aso2/cc*emis;
  qsi[n]=-bso2/log(1.+cc/enat)*log(1.+emis/enat);

 /* aerosols from biomass buring */

  qb[n]=-cso2*(e2d[n]+rg[n])/(e2d[225]+rg[225]);
  if(n>225) qb[n]=-cso2;
  if(qb[n]>0.) qb[n]=0.;
  qt[n]+=qb[n];
  if(n==1) { 
    qc2[0]=-qc2[1]; qm[0]=-qm[1]; qn[0]=-qn[1];
    qcf[0]=-qcf[1]; qt[0]=-qt[1]; qsd[0]=-qsd[1]; qsi[0]=-qsi[1];
    qb[0]=-qb[1]; qos[0]=-qos[1]; qot[0]=-qot[1];
  }
 }


  void cal_TEMPERAT(n,qt,qsd,qsi,qot,tdo,temp)
  double *qt,*qsd,*qsi,*qot,**tdo,**temp;
  int n;
{ double gqto,gqsd,gqsi,gqot,dtt,gwp,gsd,gsi,got,ql,qo,heat,hemf[2],bmd[40];
  double aal[40],bbl[40],vvl,tda[2];
  double xtzz,dtz,tpai;
  int i,j,k,nbt;

  nbt=nbox-1;
  gqto=qt[n]-qt[n-1];
  gqsd=qsd[n]-qsd[n-1];
  gqsi=qsi[n]-qsi[n-1];
  gqot=qot[n]-qot[n-1];
  
  xtzz=xk*dt/(dz*dz);  dtz=dt/dz;

  for(i=0;i<ntp;i++) {
     dtt=dt*i+0.5*dt;
     gwp=qt[n-1]+gqto*dtt;
     gsd=qsd[n-1]+gqsd*dtt;
     gsi=qsi[n-1]+gqsi*dtt;
     got=qot[n-1]+gqot*dtt;

     hemf[0]=xkns/focean[0]*(tdo[1][0]-tdo[0][0]);
     hemf[1]=xkns/focean[1]*(tdo[0][0]-tdo[1][0]);

     for(j=0;j<2;j++) {

     /* slow-down in the thermohaline circulation */
       tpai=paiup*(1.-tdo[j][0]/thtmp);

     /* Matrix coefficients */
       bmw[j]=xklo*fland[j]/(focean[j]*(xklo+xlaml*fland[j]));
       bma[j][0]=0.;
       bmb[j][0]=1.+(xlamo*(1.+bmw[j]*xlamr)*fkk+xk/(dz/2.)+tpai*psink)*dth;
       bmc[j][0]=-dth*(xk/(dz/2.)+tpai);
       bma[j][1]=-xtzz*2.;
       bmc[j][1]=-xtzz-tpai*dtz;
       bmb[j][1]=1.-bma[j][1]-bmc[j][1];   
       for(k=2;k<nbox-1;k++) {
         bma[j][k]=-xtzz;
         bmc[j][k]=-xtzz-tpai*dtz;
         bmb[j][k]=1.-bma[j][k]-bmc[j][k];
       }
       bma[j][nbox-1]=-xtzz;
       bmb[j][nbox-1]=1.+xtzz+tpai*dtz;
       bmc[j][nbox-1]=0.;

     /* Radiative Forcing Change */
       ql=gwp+(gsd*fhemd[j]*flod[0]+gsi*fhemi[j]*floi[0]+got*fhemo[j]*floo[0])
         *2./fland[j];
       qo=gwp+(gsd*fhemd[j]*flod[1]+gsi*fhemi[j]*floi[1]+got*fhemo[j]*floo[1])
         *2./focean[j];

       heat=fkk*dth*(qo+hemf[j]+bmw[j]*ql);

       for(k=0;k<nbox;k++) 
         bmd[k]=tdo[j][k];
       bmd[0]+=heat;
       bmd[nbt]+=psink*tpai*dt/dz*tdo[j][0];

      /* Solving Matrix Equation */
       aal[0]=-bmc[j][0]/bmb[j][0];
       bbl[0]=bmd[0]/bmb[j][0];
       for(k=1;k<nbt;k++) {
         vvl=bma[j][k]*aal[k-1]+bmb[j][k];
         aal[k]=-bmc[j][k]/vvl;
         bbl[k]=(bmd[k]-bma[j][k]*bbl[k-1])/vvl;
       }
       tdo[j][nbt]=(bmd[nbt]-bma[j][nbt]*bbl[nbt-1])
                         /(bma[j][nbt]*aal[nbt-1]+bmb[j][nbt]);
       for(k=nbt-1;k>-1;k--)
          tdo[j][k]=aal[k]*tdo[j][k+1]+bbl[k];

      /* calculation of land temp */
       tda[j]=(fland[j]*ql+xklo*tdo[j][0])/(fland[j]*xlaml+xklo);
     }
   }

   temp[0][n]=tda[0];
   temp[1][n]=tdo[0][0];
   temp[2][n]=tda[1];
   temp[3][n]=tdo[1][0];
   temp[4][n]=(fland[0]*temp[0][n]+focean[0]*temp[1][n]
         +fland[1]*temp[2][n]+focean[1]*temp[3][n])*0.5;
}

 void cal_SEALEVEL(n,tdo,tg,slvl)
 double **tdo,*tg,**slvl;
 int n;
{ double fsum,zlay,delt,tl1,tl2,tl3,cl,pl,dlr,aa,bb;
  int i;

/* Sea Level Rise due to Thermal Expansion */
  slvl[0][n]=0.;
  fsum=1./(focean[0]+focean[1]);
  zlay=hm;
  for(i=0;i<nbox;i++) {
     delt=(tdo[0][i]*focean[0]+tdo[1][i]*focean[1])*fsum;
     tl1=item[i]+delt/2.; tl2=tl1*tl1; tl3=tl2*tl1/6000.;
     pl=pres[i];
     cl=52.55+28.051*pl-0.7108*pl*pl+tl1*(12.9635-1.0833*pl)
       -tl2*(0.1713-0.019263*pl)+tl3*(10.41-1.1338*pl);
     dlr=cl*delt*zlay/10000.;
     zlay=dz;
     slvl[0][n]+=dlr; }

/* Ice Melt Contributions to Sea Level Rise */
  if(n < 116) {
    slvl[1][n]=0.; slvl[2][n]=0.; slvl[3][n]=0.;
  }
  else {
    delt=tg[n]-tg[115];
    aa=betai*delt;
    bb=(1.0+aa)/2.0;
    slvl[1][n]=(slvl[1][n-1]*(taui-bb)+zi0*aa)/(taui+bb);
    slvl[2][n]=slvl[2][n-1]+betag*delt*1.5;
    slvl[3][n]=slvl[3][n-1]+db3+(beta1+beta2)*delt;
  }
}


  void inv_CO2(con,ch4dat,ein,def,pla,hli,soi,eto,flu,dbdt,rgr,cp)
  double *con,*ch4dat,*ein,*def,*pla,*hli,*soi,*eto,*flu,*dbdt,*rgr,*cp;
{
  double a[5],ap[5],am[5],zz[5],ww[5];
  double tpl,tde,tso,rcgp,term1,term2,tmp,demi,tte;
  double grw,gpp,res,tf80s,td80s,dflux,cctmp;
  double amat[16],bmat[16],bc[4];
  double emi[400],defg,rg80s;
  double cff,avch4,ch4tau;
  int i,j,nd,nf;

/* Additional CO2 Emissions due to CH4 Oxidation */

  cff=fffrac*cmtb*12./16./1000.;
  for(i=1;i<226;i++) {
    avch4=(ch4dat[i]+ch4dat[i-1])*0.5;
    ch4tau=tau90*pow(avch4/ch4dat[225],powch4a);
    ein[i]+=cff/ch4tau*(avch4-ch4dat[0]);
  }

/*********** Oceanic Up-take **************/
  rcgp=1./cgtp;
  emi[0]=0.;
  nf=0;
  do {
    eto[0]=emi[0];
    smooth_ar(eto[0],a);

    for(i=0;i<5;i++) 
      refc[i]=psi/tr[i];
    refc[0]=0.;

    for(i=0;i<5;i++) {
      am[i]=a[i];
      zz[i]=refc[i];
      cp[i]=0.;
      ww[i]=1./(1.+zz[i]/2.);
    }

    for(i=1;i<226;i++) {
      term1=0.; term2=0.;
      for(j=0;j<5;j++) {
        term1+=zz[j]*cp[j]*ww[j];
        term2+=am[j]*ww[j];
      }
      tmp=rcgp*(con[i]-con[i-1]+term1)/term2;
      for(j=0;j<5;j++) ap[j]=a[j];

      do {

        tte=tmp+eto[i-1];
        smooth_ar(tte,a);

        for(j=0;j<5;j++) {
          am[j]=0.5*(a[j]+ap[j]);
          zz[j]=refc[j]-(a[j]-ap[j])/am[j];
          ww[j]=1./(1.+zz[j]/2.);
	}

        term1=0.; term2=0.;
        for(j=0;j<5;j++) {
          term1+=zz[j]*cp[j]*ww[j];
          term2+=am[j]*ww[j];
	}

        emi[i]=rcgp*(con[i]-con[i-1]+term1)/term2;
        demi=tmp-emi[i];
        tmp=(tmp+emi[i])/2.;

       } while(fabs(demi)>1.e-4);

       eto[i]=emi[i]+eto[i-1];

       for(j=0;j<5;j++)
          cp[j]=cp[j]+(am[j]*emi[i]*cgtp-zz[j]*cp[j])*ww[j];

       flu[i]=emi[i]-rcgp*(con[i]-con[i-1]); 

     }

     tf80s=0.;
     for(i=216;i<226;i++) 
       tf80s+=flu[i];
     tf80s/=10.;
     dflux=f80s-tf80s;
     psi+=gain1*dflux;

  } while((fabs(dflux)> crite1)&&(++nf<nit1));

/********** Terrestrial Carbon Cycle **************/

  tpl=0.5/tplant; tde=0.5/tdetri; tso=0.5/tsoil;

  amat[0]=zzp2; amat[1]=0.; amat[2]=0.; amat[3]=cpdm;
  amat[4]=-tpl*cplh; amat[5]=zzh2; amat[6]=0.; 
  amat[7]=chdm; amat[8]=-tpl*cpls; amat[9]=-tde*chqs;
  amat[10]=zzs2; amat[11]=csdm; amat[12]=0.; 
  amat[13]=chqm*tde; amat[14]=tso; amat[15]=1.;

  if(invmat2(4,amat,bmat)!=0) {
    printf(" Matrix is not a regular matrix!!\n"); exit(0); }

  pla[0]=plant0; hli[0]=detri0; soi[0]=soil0; rgr[0]=0.; dbdt[0]=0.;

  nd=0;

  do {

    bfert=((680.-conb)-rco2*(340.-conb))
         /((rco2-1.)*(680.-conb)*(340.-conb));
    cfert=(1.+bfert*(con0-conb))/(con0-conb);

    for(i=1;i<226;i++) {

       cctmp=(con[i]+con[i-1])*0.5;
       grw=cfert*(cctmp-conb)/(1.+bfert*(cctmp-conb));
       gpp=grw*gpp0; res=grw*res0;

       bc[0]=pla[i-1]*zzp1+cmgp*gpp-res;
       bc[1]=hli[i-1]*zzh1+cmgh*gpp+cplh*pla[i-1]*tpl-ham-hbs;
       bc[2]=soi[i-1]*zzs1+cmgs*gpp+cpls*pla[i-1]*tpl
            +chqs*hli[i-1]*tde-scm+hbs;
       bc[3]=emi[i]-ein[i]+gpp-res-chqm*hli[i-1]*tde-soi[i-1]*tso-scm-ham;

       pla[i]=0.; for(j=0;j<4;j++) pla[i]+=bmat[j]*bc[j];
       hli[i]=0.; for(j=0;j<4;j++) hli[i]+=bmat[4+j]*bc[j];
       soi[i]=0.; for(j=0;j<4;j++) soi[i]+=bmat[8+j]*bc[j];
       defg=0.; for(j=0;j<4;j++) defg+=bmat[12+j]*bc[j];

 /* regrpwth */

       rgr[i]=(zzp1*rgr[i-1]+cpdm*defg/tplant)/zzp2;
       def[i]=defg-rgr[i];

   }

   td80s=0.;
   for(i=216;i<226;i++) 
     td80s+=def[i];
   td80s/=10.;
   dflux=d80s-td80s;
   rco2+=gain2*dflux;

 } while((fabs(dflux)> crite2)&&(++nd<nit2));
    
    for(i=1;i<226;i++)
       dbdt[i]=gpp-res-scm-ham
              -(chqm*(hli[i-1]+hli[i])*tde+(soi[i-1]+soi[i])*tso);

     rg80s=0.; for(i=216;i<226;i++) rg80s+=rgr[i];  rg80s/=10.;

  if((nd<100) && (nf<100)) {
/*    printf(" The calibration of C cycle model has been done.\n");
    printf("\n");
    printf(" Iteration=%2d   F80s=%6.3f GtC/yr PSI =%8.5f\n", nf,tf80s,psi);
    printf(" Iteration=%2d   D80s=%6.3f GtC/yr BCO2=%8.5f\n", nd,td80s,rco2);
    printf("           Re-growth=%6.3f GtC/yr\n",rg80s);
    printf("\n");
    printf(" Partial Concentrations in 1990  (ppmv)\n");
    printf(" C0:%8.5f, C1:%8.5f, C2:%8.5f, C3:%8.5f, C4:%8.5f\n",
             cp[0],cp[1],cp[2],cp[3],cp[4]);
    printf("\n");
    printf(" State Variables in 1990 (GtC)\n");
    printf(" Plant:%8.3f, Detri:%8.3f, Soil:%8.3f, CumEmi:%8.3f\n",
             pla[225],hli[225],soi[225],eto[225]); 
    printf("\n"); */
  }
  else {
    printf(" The calibaration was failed!!\n");
    printf(" Iteration times for F80s : %d\n",nf);
    printf("                 for D80s : %d\n",nd);
    exit(0);
  }
}


  void cal_CO2(n,con,ch4,ein,emd,pla,hli,soi,eto,flu,dbdt,rgr,cp)
  int n;
  double *con,*ch4,*ein,*emd,*pla,*hli,*soi,*eto,*flu,*dbdt,*rgr,*cp;
{ double a[5],ap[5],am[5],zz[5],tcp[5];
  double emis,cctmp,pmm,hmm,smm,dcon,tcon;
  double grw,gpp,res,cff,defg;
  int i;

/* Additional CO2 Emissions due to CH4 Oxidation */
  cff=fffrac*cmtb*12./16./1000./methtau;
  ein[n]+=cff*((ch4[n]+ch4[n-1])*0.5-ch4[0]);

/* Gross Deforestation & Regrowth*/
  defg=(rgr[n-1]*zzp1+emd[n]*zzp2)/(zzp2-cpdm/tplant);
  rgr[n]=defg-emd[n];

  cctmp=con[n-1];
  do {
    grw=cfert*(cctmp-conb)/(1.+bfert*(cctmp-conb));
    gpp=grw*gpp0; res=grw*res0;
    pla[n]=(pla[n-1]*zzp1+cmgp*gpp-res-cpdm*defg)/zzp2;
    pmm=0.5*(pla[n]+pla[n-1])/tplant;
    hli[n]=(hli[n-1]*zzh1+cmgh*gpp+cplh*pmm-ham-hbs-chdm*defg)/zzh2;
    hmm=0.5*(hli[n]+hli[n-1])/tdetri;
    soi[n]=(soi[n-1]*zzs1+cmgs*gpp+cpls*pmm+chqs*hmm+hbs-scm-csdm*defg)/zzs2;
    smm=0.5*(soi[n]+soi[n-1])/tsoil;
    emis=ein[n]+defg-(gpp-res-chqm*hmm-smm-scm-ham);
    smooth_ar(eto[n-1],ap);
    eto[n]=eto[n-1]+emis;
    smooth_ar(eto[n],a);
    for(i=0;i<5;i++) {
       am[i]=0.5*(a[i]+ap[i]);
       zz[i]=refc[i]-(a[i]-ap[i])/am[i];
     }
    for(i=0;i<5;i++)
       tcp[i]=cp[i]+(am[i]*emis*cgtp-zz[i]*cp[i])/(1.+0.5*zz[i]);
    tcon=con[0];
    for(i=0;i<5;i++) tcon+=tcp[i];
    dcon=cctmp-(tcon+con[n-1])*0.5;
    cctmp=(2.*cctmp+tcon+con[n-1])/4.;
     } while(fabs(dcon)>1.e-4);
    con[n]=tcon;
    for(i=0;i<5;i++)
      cp[i]=tcp[i];
}

  void smooth_ar(ee,a)
  double ee,*a;
{ int i;
  double u1,u2;

  for(i=0;i<5;i++) {
     if(ee<xxe[0]) a[i]=ar[i];
     else if(ee<xxe[1]) {
        u1=ee-xxe[0];u2=u1*u1;
        a[i]=ar[i]+(bxfr[i]+axfr[i]*u1)*u2; }
     else if(ee<xxe[2]) {
        u1=ee-ell[0];
        a[i]=ar[i]+dar1[i]*u1; }
     else if(ee<xxe[3]) {
        u1=ee-xxe[2];u2=u1*u1;
        a[i]=cxfr[5+i]+dar1[i]*u1+(bxfr[5+i]+axfr[5+i]*u1)*u2; }
     else if(ee<xxe[4]) {
        u1=ee-ell[1];
        a[i]=ar[5+i]+dar2[i]*u1; }
     else if(ee<xxe[5]) {
        u1=ee-xxe[4];u2=u1*u1;
        a[i]=cxfr[10+i]+dar2[i]*u1+(bxfr[10+i]+axfr[10+i]*u1)*u2; }
     else a[i]=ar[10+i];   }  }

  
  int invmat2(n,amat,bmat)
  int n;
  double *amat,*bmat;
{ int i,j,k,i0;
  double pivot1[4],pivot2[4],pivot3[4],gm;

  for(i=0;i<n;i++) {
     for(j=0;j<n;j++) bmat[i*n+j]=0.;
     bmat[i*n+i]=1.; }
  for(j=0;j<n;j++) {
     gm=0.;
     for(i=j;i<n;i++)
       if(fabs(amat[i*n+j])>gm) {
         gm=fabs(amat[i*n+j]);
         i0=i;
       }
     if(fabs(gm)<1.e-8) return(1);
     gm=1./amat[i0*n+j];
     for(k=0;k<n;k++) {
        pivot1[k]=amat[i0*n+k]*gm; pivot2[k]=bmat[i0*n+k]*gm; }
     for(k=0;k<n;k++) {
        amat[i0*n+k]=amat[j*n+k]; bmat[i0*n+k]=bmat[j*n+k]; }
     for(k=0;k<n;k++) {
        amat[j*n+k]=pivot1[k]; bmat[j*n+k]=pivot2[k]; }
     for(i=0;i<n;i++) pivot3[i]=amat[i*n+j];
     for(i=0;i<n;i++)
        for(k=0;k<n;k++){
           amat[i*n+k]-=pivot3[i]*pivot1[k];
           bmat[i*n+k]-=pivot3[i]*pivot2[k];}
     for(k=0;k<n;k++) {
        amat[j*n+k]=pivot1[k];
        bmat[j*n+k]=pivot2[k]; }   }
   return(0); }

 void cal_CH4(n,con,ch4,co,voc,nox)
 double *con,*ch4,*nox,*co,*voc;
 int n;
{ double ctmp,ttmp,coc,tau,co90,xnox,xvoc,xch4,yy,y,aa,bb,cc;
  double dtt,dcc;

  ctmp=con[n-1];
  ttmp=methtau;
  co90=co[225]+ch4soc+vocsoc;
  xnox=pow((nox[n]/nox[225]),powno);
  xvoc=pow((voc[n]/voc[225]),powvo);

  do{
    xch4=(ctmp+con[n-1])/(con[225]+con[224]);
    do {
      coc=ch4soc*xch4*(tau90/ttmp)+vocsoc*(voc[n]/voc[225]);
      tau=tau90*pow(xch4,powch4)*pow((co[n]+coc)/co90,powco)*xnox*xvoc;
      dtt=tau-ttmp;
      ttmp=(ttmp+tau)/2.;
    } while(fabs(dtt)>1.e-4);
    yy=powch4*0.5/tau;
    y=1./tau+1./tausoil;
    aa=ch4[n]/cmtb-con[n-1]*y;
    bb=1.+y*0.5-yy;
    cc=con[n-1]+aa/bb;
    dcc=cc-ctmp;
    ctmp=(ctmp+cc)/2.;
  } while(fabs(dcc)>1.e-4);
  con[n]=cc;
  methtau=tau;
}

 void cal_N2O(n,con,emi)
 double *con,*emi;
 int n;
{ double tt;
  tt=0.5/taun2o;
  con[n]=(con[n-1]*(1.-tt)+emi[n]/cfn2o)/(1.+tt);
}

 void cal_CFCs(n,con,emi)
 double **con,**emi;
 int n;
{ double tt;
  int i;
  for(i=0;i<27;i++) {
    tt=0.5/taucfc[i];
    con[i+icfc][n]=(con[i+icfc][n-1]*(1.-tt)+emi[i+icfc][n]/cfcfc[i])/(1.+tt);
  }
}


  void interpolate(nt,yr,d,e)
  int nt,*yr;
  double *d,*e;
{ double ac,dyr,yrr;
  int i,j,dy,cyr;
  cyr=yr[0]-1765;
  e[cyr]=d[0];
  for(i=1;i<nt;i++) {
    dy=yr[i]-yr[i-1];
    dyr=1./(double)dy;
    ac=(d[i]-d[i-1])*dyr;
    for(j=0;j<dy;j++) {
      yrr=(double)j+1.;
      e[++cyr]=d[i-1]+ac*yrr;
    }
  }
}

